#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <dirent.h>

#include "bgs_gen.h"

void usage()
{

    putchar('\n');
    puts("-p path\t\t\tthe path where pics stored");
    puts("-d minutes\t\thow long current pic  will last in minutes");
    puts("example");
    puts("bgs_gen -p /usr/share/backgrounds/myfiles");
    puts("bgs_gen -p /usr/share/backgrounds/myfiles -d 100");
}

void version()
{
    puts("Backgroung Switch Config File Generator");
    puts("Version 1.0");
    puts("Author Jones");
    printf("Date:%s\n",__DATE__);

}
int check_dir(char * p_path)
{
    if(NULL==p_path)
    {
        puts("bad path");
        return -1;
    }
    if(-1==access(p_path,R_OK))
    {
        puts("Error:");
        fflush(stdout);
        perror(p_path);
        return -1;
    }
    return 0;
}


inline void put_tab(int i,FILE * p_file)
{
    while(i>0)
    {
        fprintf(p_file,"\t");
        --i;
    }
}
void write_start(FILE * p_file)
{
    fputs("<background>\n",p_file);

    put_tab(1,p_file);
    fputs("<starttime>\n",p_file);

    put_tab(2,p_file);
    fputs("<year>2009</year>\n",p_file);

    put_tab(2,p_file);
    fputs("<month>08</month>\n",p_file);

    put_tab(2,p_file);
    fputs("<day>04</day>\n",p_file);

    put_tab(2,p_file);
    fputs("<hour>00</hour>\n",p_file);

    put_tab(2,p_file);
    fputs("<minute>00</minute>\n",p_file);

    put_tab(2,p_file);
    fputs("<second>00</second>\n",p_file);

    put_tab(1,p_file);
    fputs("</starttime>\n",p_file);

    fputs("<!-- This animation will start at midnight. -->\n",p_file);
}
inline void write_end(FILE * p_file)
{
    fputs("</background>",p_file);
}
char*  write_blocks(FILE *p_file,char *p_path,DIR *p_dir,char *first,int duration)
{
    struct  dirent * p_de;


    if(NULL!=(p_de=readdir(p_dir)))
    {
        if('.'!=p_de->d_name[0])
        {

            put_tab(1,p_file);
            fputs("<static>\n",p_file);
            put_tab(2,p_file);
            fprintf(p_file,"%s%.1f%s\n","<duration>",duration*60.0,"</duration>");
            put_tab(2,p_file);
            fprintf(p_file,"%s%s%s%s\n","<file>",p_path,first,"</file>");


            put_tab(1,p_file);
            fputs("</static>\n",p_file);

            put_tab(1,p_file);
            fputs("<transition>\n",p_file);

            put_tab(2,p_file);
            fputs("<duration>5.0</duration>\n",p_file);

            put_tab(2,p_file);
            fprintf(p_file,"%s%s%s%s\n","<from>",p_path,first,"</from>");
            put_tab(2,p_file);
            fprintf(p_file,"%s%s%s%s\n","<to>",p_path,p_de->d_name,"</to>");

            put_tab(1,p_file);
            fputs("</transition>\n",p_file);
            return write_blocks(p_file,p_path,p_dir,p_de->d_name,duration);

        }
    }
    return  first;
}

void write_block(FILE *p_file,char *p_path,char* first,char *second,int duration)
{

    put_tab(1,p_file);
    fputs("<static>\n",p_file);
    put_tab(2,p_file);
    fprintf(p_file,"%s%.1f%s\n","<duration>",60.0*duration,"</duration>");
    put_tab(2,p_file);
    fprintf(p_file,"%s%s%s%s\n","<file>",p_path,first,"</file>");


    put_tab(1,p_file);
    fputs("</static>\n",p_file);

    put_tab(1,p_file);
    fputs("<transition>\n",p_file);

    put_tab(2,p_file);
    fputs("<duration>5.0</duration>\n",p_file);

    put_tab(2,p_file);
    fprintf(p_file,"%s%s%s%s\n","<from>",p_path,first,"</from>");
    put_tab(2,p_file);
    fprintf(p_file,"%s%s%s%s\n","<to>",p_path,second,"</to>");

    put_tab(1,p_file);
    fputs("</transition>\n",p_file);

}
